#include <fstream.h>  // TEST
#include <stdlib.h>


#include "Hash.h"
#include "d_Util.h"

//-----------------------------------------------------------------------------------
/* ?    
 *   
 *
 *  ChessTerminator75
 *   15.12.2007
 *
 *  
 *        
*/
//---------------------------------------------------------------------------


//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
 ofstream Test_Hash;
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
//          
//             
//         
//       
//            
//     
//      
// 3*7*120=2520 
int random_piese_key[3][7][120];


//	===================================================================
void Ini_random_piese_key(){

//        
//<cstdlib>	      0  32767

//int rand ( void ); 
//Returns a pseudo-random integral number in the range 0 to RAND_MAX.
//RAND_MAX is a constant defined in <cstdlib>. Its default value may vary between 
//implementations but it is granted to be at least 32767.

 for(int c=1 ; c<3 ; c++){
	 for(int n=1 ; n<7 ; n++){
		for(int q=0 ; q<120 ; q++){
              random_piese_key[c][n][q]=rand();
//Test_Hash << "random_piese_key[" << c << "][" << n << "][" << q << "]= " << random_piese_key[c][n][q] << "\n";
	    }//for(int q=0 ; q<120 ; q++){
	 }//for(int n=1 ; n<7 ; n++){
 }//for(int c=1 ; c<3 ; c++){

}//Ini_random_piese_key(){
//	*******************************************************************

//	===================================================================
void Start_position_random_key(T_board_list_816 * board_list_816){
short int  n_1 = 0;
short int  colour;
short int  name;

//Integer.         4bytes            signed: -2147483648 to 2 147 483 647
//32767*32=1 048 544      
int key=32767;

n_1 = 0;
while (n_1<120){
 colour=board_list_816->colour_figure_816[n_1];
    if (!(n_1 & 0x88)&&(colour!=0)){
      name=board_list_816->name_figure_816[n_1];
      key=key+random_piese_key[colour][name][n_1];
    }//if (!(n_1 & 0x88)&&(board_list_816->colour_figure_816[n_1]!=0)){
  n_1 = n_1 + 1;
}//while (n_1<129){
board_list_816->hash_key=key;

}//Start_position_random_key(T_board_list_816 * board_list_816){
//	*******************************************************************

//	===================================================================
void Modification_up_random_key(short int i,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816){
int key ; //   
int key_mem ;//   
short int name_figure;//    
short int  initial_position;//   
short int  final_position;//     
short int  colour_figure;//    

key_mem=board_list_816->hash_key;
name_figure=list_surplus_moves->name_figure[i];
initial_position=list_surplus_moves->initial_position[i];
final_position=list_surplus_moves->final_position[i];
colour_figure=board_list_816->colour_figure_816[final_position];

//         
//     
//           
//   

key=key_mem-random_piese_key[colour_figure][name_figure][initial_position];
key=key+random_piese_key[colour_figure][name_figure][final_position];
board_list_816->hash_key=key;


}//void Modification_up_random_key(short int i,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816){
//	*******************************************************************

//	===================================================================
void Modification_down_random_key(short int i,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816){
int key ; //   
int key_mem ;//   
short int name_figure;//    
short int  initial_position;//   
short int  final_position;//     
short int  colour_figure;//    

key_mem=board_list_816->hash_key;
name_figure=list_surplus_moves->name_figure[i];
initial_position=list_surplus_moves->initial_position[i];
final_position=list_surplus_moves->final_position[i];
colour_figure=board_list_816->colour_figure_816[initial_position];

//         
//     
//           
//   

key=key_mem+random_piese_key[colour_figure][name_figure][initial_position];
key=key-random_piese_key[colour_figure][name_figure][final_position];
board_list_816->hash_key=key;

}//void Modification_down_random_key(short int i,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816){
//	*******************************************************************

//	===================================================================
//
void Save_hash_key(short int i,T_list_surplus_moves * list_surplus_moves,int key,T_hash_moves * hash_moves,short int depth){

hash_moves[key].key=key;
hash_moves[key].depth=depth;
hash_moves[key].initial_position =list_surplus_moves->initial_position[i];
hash_moves[key].final_position   =list_surplus_moves->final_position[i];

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
    Test_Hash.open ("_TEST_HASH.txt",ios::app);
 //   Test_Hash.open ("_TEST_HASH.txt");
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

#if TEST_H
 Test_Hash << " "<< "\n";
 Test_Hash << "key= "<< key << "\n";
 Test_Hash << "depth= "<< depth << "\n";
 Test_Hash << "hash_moves[key].initial_position= "<< hash_moves[key].initial_position << "\n";
 Test_Hash << "hash_moves[key].final_position= "<< hash_moves[key].final_position << "\n";
 Test_Hash << "                "<< "\n";
 Test_Hash <<" "<<(x_to_notation(hash_moves[key].initial_position%16));
 Test_Hash <<""<<(8-hash_moves[key].initial_position/16);
 Test_Hash <<" "<<(x_to_notation(hash_moves[key].final_position%16));
 Test_Hash <<""<<(8-hash_moves[key].final_position/16) << "\n";
#endif 

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
    Test_Hash.close();
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

}//Save_hash_key(short int i,T_list_surplus_moves * list_surplus_moves,T_board_list_816 * board_list_816,T_hash_moves * hash_moves){
//	*******************************************************************

//	===================================================================
void Insert_hash_moves(T_list_surplus_moves * list_surplus_moves,int key,T_hash_moves * hash_moves,short int depth){
 //   1-  2-  3-  4-  5-  6-  
short int name_figure_s;
 //    1-  2-  3-  4-  5-  6-  
short int name_taking_figure_s;
//   (  )
short int initial_position_s; 
//   (  )
short int final_position_s;
//     0,  1,    2,  3,
//  4,    5
short int description_move_s;

int n=list_surplus_moves->start_list[depth];

 for (short int i=list_surplus_moves->start_list[depth];i<list_surplus_moves->end_list[depth];i++){	

  if(((list_surplus_moves->initial_position[i]==hash_moves[key].initial_position)&&(list_surplus_moves->final_position[i]==hash_moves[key].final_position))){
//    n ..      
	 name_figure_s        = list_surplus_moves->name_figure[n];
	 name_taking_figure_s = list_surplus_moves->name_taking_figure[n];
     initial_position_s   = list_surplus_moves->initial_position[n];
     final_position_s     = list_surplus_moves->final_position[n];
     description_move_s   = list_surplus_moves->description_move[n];

//   i  n ..    
	 list_surplus_moves->name_figure[n]        = list_surplus_moves->name_figure[i];
	 list_surplus_moves->name_taking_figure[n] = list_surplus_moves->name_taking_figure[i];
     list_surplus_moves->initial_position[n]   = list_surplus_moves->initial_position[i];
     list_surplus_moves->final_position[n]     = list_surplus_moves->final_position[i];
     list_surplus_moves->description_move[n]   = list_surplus_moves->description_move[i];


//  
	 list_surplus_moves->name_figure[i]        = name_figure_s;
	 list_surplus_moves->name_taking_figure[i] = name_taking_figure_s;
     list_surplus_moves->initial_position[i]   = initial_position_s;
     list_surplus_moves->final_position[i]     = final_position_s;
     list_surplus_moves->description_move[i]   = description_move_s;
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
    Test_Hash.open ("_TEST_HASH.txt",ios::app);
 //   Test_Hash.open ("_TEST_HASH.txt");
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT

#if TEST_H
 Test_Hash << " "<< "\n";
 Test_Hash << "key= "<< key << "\n";
 Test_Hash << "depth= "<< depth << "\n";
 Test_Hash << "hash_moves[key].initial_position= "<< hash_moves[key].initial_position << "\n";
 Test_Hash << "hash_moves[key].final_position= "<< hash_moves[key].final_position << "\n";
 Test_Hash << "                "<< "\n";
 Test_Hash <<" "<<(x_to_notation(hash_moves[key].initial_position%16));
 Test_Hash <<""<<(8-hash_moves[key].initial_position/16);
 Test_Hash <<" "<<(x_to_notation(hash_moves[key].final_position%16));
 Test_Hash <<""<<(8-hash_moves[key].final_position/16) << "\n";
#endif 

//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
#if TEST_H
    Test_Hash.close();
#endif 
//TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
	 break;
  }//if(list_surplus_moves->description_move[i] ==1){

 }//for (i=0,i<list_surplus_moves->amount_moves){


}//Insert_hash_moves(T_list_surplus_moves * list_surplus_moves,int key,T_hash_moves * hash_moves,short int depth){
//	*******************************************************************



